"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getSourceWithSourceCodeLocation = getSourceWithSourceCodeLocation;
var parse5_1 = require("parse5");
function getSourceWithSourceCodeLocation(_a) {
    var _b, _c, _d;
    var source = _a.source, filePath = _a.filePath, htmlTags = _a.htmlTags;
    var ast = (0, parse5_1.parseFragment)(source, {
        sourceCodeLocationInfo: true,
    });
    var allNodes = [ast];
    var nodeIndex = 0;
    while (allNodes.length > nodeIndex) {
        allNodes = allNodes.concat(((_b = allNodes[nodeIndex]) === null || _b === void 0 ? void 0 : _b.childNodes) || [], ((_d = (_c = allNodes[nodeIndex]) === null || _c === void 0 ? void 0 : _c.content) === null || _d === void 0 ? void 0 : _d.childNodes) || []);
        nodeIndex++;
    }
    var startOffsetSet = new Set();
    var sortedNodes = allNodes
        .filter(function (node) {
        var _a;
        if (!((_a = node === null || node === void 0 ? void 0 : node.sourceCodeLocation) === null || _a === void 0 ? void 0 : _a.startOffset)) {
            return false;
        }
        var startOffset = node.sourceCodeLocation.startOffset;
        if (startOffsetSet.has(startOffset)) {
            return false;
        }
        startOffsetSet.add(startOffset);
        if (!htmlTags.includes(node === null || node === void 0 ? void 0 : node.nodeName)) {
            return false;
        }
        return true;
    })
        .sort(function (a, b) {
        return b.sourceCodeLocation.startOffset - a.sourceCodeLocation.startOffset;
    });
    var result = source;
    sortedNodes.forEach(function (node) {
        var _a = node.sourceCodeLocation, startOffset = _a.startOffset, startLine = _a.startLine, startCol = _a.startCol;
        var sourceCodeLocation = " data-__source-code-location=\"".concat(filePath, ":").concat(startLine, ":").concat(startCol, "\" ");
        var insertPos = startOffset + node.nodeName.length + 1;
        result =
            result.substring(0, insertPos) +
                sourceCodeLocation +
                result.substring(insertPos);
    });
    return result;
}
